// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/CheckApostrophe.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class CheckApostrophe extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inTag = 2;
  public static final int inPre = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\34\u0200\1\u0300\1\u0200\1\u0400\1\u0500\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\3\22\0\1\1"+
    "\5\0\1\4\1\5\7\0\1\6\12\7\1\10\1\11"+
    "\1\12\1\0\1\13\2\0\1\14\1\15\1\16\1\17"+
    "\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27"+
    "\1\30\1\31\1\32\1\33\1\25\1\34\1\35\1\36"+
    "\1\37\4\25\1\40\6\0\1\14\1\15\1\16\1\17"+
    "\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27"+
    "\1\30\1\31\1\32\1\33\1\25\1\34\1\35\1\36"+
    "\1\37\4\25\1\40\105\0\6\7\1\0\11\7\1\0"+
    "\6\7\2\0\4\7\3\0\6\7\1\0\11\7\1\0"+
    "\6\7\2\0\4\7\53\0\2\7\6\0\2\41\66\0"+
    "\2\7\4\0\2\7\17\0\1\42\u0188\0\2\7\216\0"+
    "\2\7\42\0\2\7\104\0\1\1\u0127\0\1\43\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\4\1\1\2\1\3\1\1\33\0\2\4\1\0"+
    "\2\5\5\0\1\6\2\7\1\10\4\0\1\11\12\0"+
    "\1\12\31\0\1\13\1\14\32\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[120];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\44\0\110\0\154\0\220\0\264\0\330\0\374"+
    "\0\330\0\u0120\0\u0144\0\u0168\0\u018c\0\u01b0\0\u01d4\0\u01f8"+
    "\0\u021c\0\154\0\u0240\0\u0264\0\u0288\0\u02ac\0\u02d0\0\u02f4"+
    "\0\u0318\0\u033c\0\u0360\0\u0384\0\u03a8\0\u03cc\0\u03f0\0\u0414"+
    "\0\u0438\0\u045c\0\u0480\0\u04a4\0\u04c8\0\330\0\u04ec\0\u0510"+
    "\0\330\0\u0534\0\u0558\0\u057c\0\u05a0\0\u05c4\0\u05e8\0\330"+
    "\0\330\0\u060c\0\330\0\u0630\0\u0654\0\u0678\0\u069c\0\330"+
    "\0\u06c0\0\u06e4\0\u0708\0\u072c\0\u0750\0\u0774\0\u0798\0\u07bc"+
    "\0\u07e0\0\u0804\0\330\0\u0828\0\u084c\0\u0870\0\u0894\0\u08b8"+
    "\0\u08dc\0\u0900\0\u0924\0\u0948\0\u096c\0\u0990\0\u09b4\0\u09d8"+
    "\0\u09fc\0\u0a20\0\u0a44\0\u0a68\0\u0a8c\0\u0ab0\0\u0ad4\0\u0af8"+
    "\0\u0b1c\0\u0b40\0\u0b64\0\u0b88\0\330\0\330\0\u0bac\0\u0bd0"+
    "\0\u0bf4\0\u0c18\0\u0c3c\0\u0c60\0\u0c84\0\u0ca8\0\u0ccc\0\u0cf0"+
    "\0\u0d14\0\u0d38\0\u0d5c\0\u0d80\0\u0da4\0\u0dc8\0\u0dec\0\u0e10"+
    "\0\u0e34\0\u0e58\0\u0e7c\0\u0ea0\0\u0ec4\0\u0ee8\0\u0f0c\0\u0f30";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[120];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\3\4\1\5\1\4\1\6\1\4\1\7\2\4\1\10"+
    "\1\4\25\7\3\4\13\7\1\11\42\7\1\12\31\7"+
    "\14\0\1\13\1\14\1\15\1\16\1\13\3\14\1\13"+
    "\5\14\1\13\1\17\3\14\1\20\1\14\1\21\4\0"+
    "\1\22\11\0\1\13\1\14\1\15\1\16\1\13\3\14"+
    "\1\13\5\14\1\13\1\17\3\14\1\20\1\14\1\21"+
    "\16\0\1\23\1\24\1\25\1\26\1\23\3\24\1\23"+
    "\5\24\1\23\1\27\3\24\1\30\1\24\1\31\62\0"+
    "\1\13\1\14\1\15\1\16\1\13\2\14\1\32\1\13"+
    "\3\14\1\33\1\14\1\13\1\17\3\14\1\20\1\14"+
    "\1\21\10\0\1\34\42\0\1\35\6\0\1\13\3\14"+
    "\1\13\3\14\1\13\5\14\1\13\4\14\1\13\1\14"+
    "\1\21\16\0\1\13\3\14\1\13\3\14\1\13\5\14"+
    "\1\13\4\14\1\13\1\14\1\21\16\0\1\13\3\14"+
    "\1\36\3\14\1\13\5\14\1\13\4\14\1\13\1\14"+
    "\1\21\16\0\1\13\3\14\1\37\3\14\1\13\5\14"+
    "\1\13\4\14\1\13\1\14\1\21\16\0\1\13\3\14"+
    "\1\13\3\14\1\13\5\14\1\37\4\14\1\13\1\14"+
    "\1\21\7\0\1\35\6\0\1\13\3\14\1\37\3\14"+
    "\1\13\5\14\1\13\4\14\1\13\1\14\1\21\7\0"+
    "\1\35\43\0\1\40\6\0\1\23\3\24\1\23\3\24"+
    "\1\23\5\24\1\23\4\24\1\23\1\24\1\31\16\0"+
    "\1\23\3\24\1\23\3\24\1\23\5\24\1\23\4\24"+
    "\1\23\1\24\1\31\16\0\1\23\3\24\1\41\3\24"+
    "\1\23\5\24\1\23\4\24\1\23\1\24\1\31\16\0"+
    "\1\23\3\24\1\42\3\24\1\23\5\24\1\23\4\24"+
    "\1\23\1\24\1\31\16\0\1\23\3\24\1\23\3\24"+
    "\1\23\5\24\1\42\4\24\1\23\1\24\1\31\7\0"+
    "\1\40\6\0\1\23\3\24\1\42\3\24\1\23\5\24"+
    "\1\23\4\24\1\23\1\24\1\31\7\0\1\40\46\0"+
    "\1\43\3\0\1\13\3\14\1\13\3\14\1\13\5\14"+
    "\1\13\4\14\1\13\1\14\1\21\16\0\1\13\3\14"+
    "\1\13\3\14\1\13\5\14\1\13\1\14\1\44\2\14"+
    "\1\13\1\14\1\21\25\0\1\45\20\0\3\46\1\47"+
    "\3\46\1\0\4\46\25\0\3\46\5\0\1\50\6\0"+
    "\1\13\3\14\1\37\3\14\1\13\5\14\1\13\4\14"+
    "\1\13\1\14\1\21\7\0\1\50\6\0\1\13\3\14"+
    "\1\13\3\14\1\13\5\14\1\13\4\14\1\13\1\14"+
    "\1\21\2\0\3\51\1\52\3\51\1\0\4\51\25\0"+
    "\3\51\5\0\1\50\6\0\1\23\3\24\1\42\3\24"+
    "\1\23\5\24\1\23\4\24\1\23\1\24\1\31\7\0"+
    "\1\50\6\0\1\23\3\24\1\23\3\24\1\23\5\24"+
    "\1\23\4\24\1\23\1\24\1\31\35\0\1\53\2\0"+
    "\1\54\21\0\1\13\3\14\1\13\3\14\1\13\1\14"+
    "\1\55\3\14\1\13\4\14\1\13\1\14\1\21\1\0"+
    "\1\56\10\0\1\57\35\0\1\60\41\0\3\61\1\62"+
    "\3\61\1\0\4\61\25\0\3\61\2\0\1\63\75\0"+
    "\1\64\23\0\1\65\37\0\1\66\3\0\1\13\3\14"+
    "\1\13\3\14\1\13\5\14\1\13\4\14\1\13\1\14"+
    "\1\21\12\0\1\66\66\0\1\67\12\0\1\70\61\0"+
    "\1\71\40\0\1\72\42\0\1\73\1\0\1\74\10\0"+
    "\1\75\1\0\1\76\1\0\1\77\1\0\1\100\1\101"+
    "\3\0\1\100\35\0\1\102\7\0\13\71\1\103\30\71"+
    "\27\0\1\104\43\0\1\105\4\0\1\106\23\0\1\107"+
    "\15\0\1\110\31\0\1\111\3\0\1\112\14\0\1\112"+
    "\41\0\1\113\20\0\1\114\47\0\1\115\11\0\1\116"+
    "\35\0\1\117\14\0\1\117\22\0\1\120\43\0\1\121"+
    "\52\0\1\122\52\0\1\123\40\0\1\124\40\0\1\125"+
    "\51\0\1\126\22\0\1\127\56\0\1\130\47\0\1\131"+
    "\47\0\1\132\41\0\1\133\43\0\1\134\20\0\1\135"+
    "\30\0\13\121\1\136\30\121\20\0\1\137\47\0\1\140"+
    "\14\0\1\140\34\0\1\141\41\0\1\142\51\0\1\143"+
    "\41\0\1\124\27\0\1\127\37\0\1\144\21\0\1\145"+
    "\31\0\1\146\14\0\1\146\40\0\1\147\37\0\1\150"+
    "\33\0\1\151\37\0\1\134\25\0\13\121\1\0\30\121"+
    "\14\0\1\152\47\0\1\153\45\0\1\154\41\0\1\141"+
    "\55\0\1\155\43\0\1\156\40\0\1\124\30\0\1\157"+
    "\30\0\1\141\2\0\1\160\6\0\1\136\64\0\1\161"+
    "\43\0\1\162\40\0\1\145\43\0\1\76\50\0\1\163"+
    "\36\0\1\164\26\0\1\141\43\0\1\165\61\0\1\152"+
    "\26\0\1\166\47\0\1\124\57\0\1\167\4\0\1\167"+
    "\34\0\1\170\21\0\1\141\32\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[3924];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\3\1\1\11\1\1\1\11\1\1\33\0\1\11"+
    "\1\1\1\0\1\11\1\1\5\0\2\11\1\1\1\11"+
    "\4\0\1\11\12\0\1\11\31\0\2\11\32\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[120];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	CheckApostrophe() { }
	
	boolean check() {
		
		String strip = yytext().substring(1);
		
		String wordLastChar = Util.getAccent(strip.toLowerCase());
		
		if(wordLastChar == null) {
			
			return false;
		}
		
		if(Character.isUpperCase(strip.charAt(strip.length()-2))) {
			
			output.append(wordLastChar.toUpperCase());
			
		} else {
			
			output.append(wordLastChar);
		}
		
		return true;
	}	

	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public CheckApostrophe(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 13: break;
          case 2:
            { output.append(yytext());
	yybegin(inTag);
            }
          // fall through
          case 14: break;
          case 3:
            { yypushback(1); yybegin(0);
            }
          // fall through
          case 15: break;
          case 4:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -1);
            { output.append(yytext().substring(0, yylength()-2));
	
	if( !check()) {
		
		output.append(yytext().substring(yylength()-2));
		
		//Per il momento non fare segnalazioni per allegati e tabelle
		String id = getMarkerDocument().getContext().getContainerId();
		
		//if(id.indexOf("annex") == -1 && id.indexOf("table") == -1) {
		if(id.indexOf("allegato") == -1 && id.indexOf("tabella") == -1) { 
			
			getMarkerDocument().addWarning("idref:" + id + " Termine con apostrofo non convertito in accento: " + yytext().substring(1));
		}
	}
            }
          // fall through
          case 16: break;
          case 5:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -1);
            { output.append(yytext().substring(0, yylength()-2));
	
	if( !check()) {
		
		output.append(yytext().substring(yylength()-2));
	}
            }
          // fall through
          case 17: break;
          case 6:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -2);
            { output.append(yytext().substring(0, yylength()-2));
	
	if( !check()) {
		
		output.append(yytext().substring(yylength()-2));
		
		//Per il momento non fare segnalazioni per allegati e tabelle
		String id = getMarkerDocument().getContext().getContainerId();
		
		//if(id.indexOf("annex") == -1 && id.indexOf("table") == -1) {
		if(id.indexOf("allegato") == -1 && id.indexOf("tabella") == -1) { 
			
			getMarkerDocument().addWarning("idref:" + id + " Termine con apostrofo non convertito in accento: " + yytext().substring(1));
		}
	}
            }
          // fall through
          case 18: break;
          case 7:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -1);
            { output.append(yytext());
            }
          // fall through
          case 19: break;
          case 8:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -2);
            { output.append(yytext().substring(0, yylength()-2));
	
	if( !check()) {
		
		output.append(yytext().substring(yylength()-2));
	}
            }
          // fall through
          case 20: break;
          case 9:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -2);
            { output.append(yytext());
            }
          // fall through
          case 21: break;
          case 10:
            { /* 
	Non sostituire gli apostrofi dentro i PRE
	(in caso di tabelle non ben formattate si individuano meglio gli errori lasciando il testo originale 
	*/
	
	output.append(yytext());
	yybegin(inPre);
            }
          // fall through
          case 22: break;
          case 11:
            { yypushback(yylength()); yybegin(0);
            }
          // fall through
          case 23: break;
          case 12:
            { getMarkerDocument().getContext().updateContainer(yytext());
	
	output.append(yytext().substring(0,yylength()-1));
	
	yypushback(1);
            }
          // fall through
          case 24: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java CheckApostrophe [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        CheckApostrophe scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new CheckApostrophe(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
